import { Entity } from "./Entity";
import { EntityManager } from "./Manager/EntityManager";
import { Collection } from "wonder-commonlib/dist/commonjs/Collection";
import { Component } from "../Component";
import { ComponentManager } from "./Manager/ComponentManager";
import { Renderer } from "../renderer/render/Renderer";
import { Geometry } from "../../Component/Geometry/Geometry";
import { Transform } from "../../Component/Transform/Transform";
import { GameObject } from "./GameObject";
export declare abstract class EntityObject extends Entity {
    readonly transform: Transform;
    readonly geometry: Geometry;
    parent: EntityObject;
    name: string;
    protected _entityManager: EntityManager;
    protected _componentManager: ComponentManager;
    initWhenCreate(): void;
    init(): this;
    render(renderer: Renderer, camera: GameObject): void;
    protected abstract createTransform(): any;
    dispose(): this;
    hasChild(child: EntityObject): boolean;
    addChild(child: EntityObject): this;
    addChildren(children: EntityObject): any;
    addChildren(children: Array<EntityObject>): any;
    addChildren(children: Collection<EntityObject>): any;
    forEach(func: (child: EntityObject, index: number) => void): this;
    filter(func: (child: EntityObject, index: number) => boolean): Collection<EntityObject>;
    getChildren(): Collection<any>;
    getAllChildren(): Collection<EntityObject>;
    getChild(index: number): any;
    findChildById(uid: number): any;
    findChildByName(name: string): any;
    findChildrenByName(name: string): Collection<EntityObject>;
    removeChild(child: EntityObject): EntityManager;
    removeAllChildren(): void;
    addComponent(component: Component): void;
    getComponent<T>(componentClass: any): T;
    hasComponent<T>(componentClass: any): boolean;
    removeComponent(component: Component): void;
    removeAllComponent(): void;
}
